<template>
  <div class="overflow-auto bg-background2 bk8-profile h-screen">
    <div class="px-5 pt-5 mb-3 m-page-header bg-x0030">
      <div class="overflow-hidden background-header-title">
        <img class="w-full h-full absolute top-0 left-0" :src="getAssetImage('assets/theme/new_black_theme/profile_bg.png')" />
      </div>
    </div>
    <div :class="{ 'px-2': isPlayful }" class="fixed w-full p-4">
      <div class="flex flex-col padding-x">
        <utils-mobile-account-information />
          <div class="overflow-auto rounded-lg mt-[10px] h-[calc(100vh-286px)] pb-48">
          <div
            class="flex flex-col pl-5 pr-5 rounded-lg bg-background5 padding-x"
          >
            <div class="flex flex-col">
              <nuxt-link class="py-[16.5px] m-profile-menu-item" to="/Account" :id="`${ID.USER_CENTER.ACCOUNT}`">
                <div class="flex items-center justify-between pointer-events-none">
                  <div class="flex items-center fc-text">
                    <svg-icon
                      svg-name="icon-profile-new"
                      class="!fill-[var(--text5)] icon w-6 h-6"
                    />
                    <span class="profile-menu-title">{{ $t("profile") }}</span>
                  </div>
                  <div class="flex items-center m-angle-right-container">
                    <font-awesome-icon icon="angle-right" />
                  </div>
                </div>
              </nuxt-link>
              <nuxt-link class="py-[16.5px] m-profile-menu-item" to="/wallet" :id="`${ID.USER_CENTER.WALLET}`">
                <div class="flex justify-between pointer-events-none">
                  <div class="flex items-center fc-text">
                    <svg-icon
                      svg-name="icon-aWallet"
                      class="!fill-[var(--text5)] icon w-6 h-6"
                    />
                    <span class="profile-menu-title">{{ $t("wallet") }}</span>
                  </div>
                  <div class="flex items-center m-angle-right-container">
                    <font-awesome-icon icon="angle-right" />
                  </div>
                </div>
              </nuxt-link>
              <nuxt-link
                class="py-[16.5px] m-profile-menu-item"
                to="/bet-history"
                :id="`${ID.USER_CENTER.BET_HISTORY}`"
              >
                <div class="flex justify-between pointer-events-none">
                  <div class="flex items-center fc-text">
                    <!-- <span v-html="betHistoryIcon" class="icon"></span> -->
                    <svg-icon
                      svg-name="icon-fBetHistory"
                      class="!fill-[var(--text5)] icon w-6 h-6"
                    />
                    <span class="profile-menu-title">{{
                      $t("bet_history")
                    }}</span>
                  </div>
                  <div class="flex items-center m-angle-right-container">
                    <font-awesome-icon icon="angle-right" />
                  </div>
                </div>
              </nuxt-link>
              <nuxt-link
                class="py-[16.5px] m-profile-menu-item"
                to="/transaction-history"
                :id = "`${ID.USER_CENTER.TRANSACTION_HISTORY}`"
              >
                <div class="flex justify-between pointer-events-none">
                  <div class="flex items-center fc-text">
                    <!-- <span v-html="statementIcon" class="icon"></span> -->
                    <svg-icon
                      svg-name="icon-statement"
                      class="!fill-[var(--text5)] icon w-6 h-6"
                    />
                    <span class="profile-menu-title">{{
                      $t("statement")
                    }}</span>
                  </div>
                  <div class="flex items-center m-angle-right-container">
                    <font-awesome-icon icon="angle-right" />
                  </div>
                </div>
              </nuxt-link>
              <nuxt-link
                v-if="referralEnabled && !isV2ReferralEnabled"
                to="/referral"
                class="py-[16.5px] m-profile-menu-item"
                :id = "`${ID.USER_CENTER.REFERRAL}`"
              >
                <div class="flex justify-between pointer-events-none">
                  <div class="flex items-center fc-text">
                    <font-awesome-icon
                      v-if="themeColor.Text === 'bk8'"
                      icon="fa-solid fa-users"
                      class="!fill-[var(--text5)] icon w-6 h-6"
                     />
                    <svg-icon
                      v-else
                      svg-name="icon-newReferral"
                      class="icon w-[24px] h-[24px]"
                    />
                    <!-- <img :src="getAssetImage('assets/theme/new_black_theme/profile/Referral.svg')" alt="" class="m-0 w-[24px] h-[24px]"> -->
                    <span class="profile-menu-title">{{ $t("referral") }}</span>
                  </div>
                  <div class="flex items-center m-angle-right-container">
                    <font-awesome-icon icon="angle-right" />
                  </div>
                </div>
              </nuxt-link>
              <nuxt-link
                v-if="isReferralV2Enabled && isShowReferralPage"
                to="/referral-v2/information"
                class="py-[16.5px] m-profile-menu-item"
                :id = "`${ID.USER_CENTER.REFERRAL}`"
              >
                <div class="flex justify-between pointer-events-none">
                  <div class="flex items-center fc-text">
                    <font-awesome-icon
                      v-if="themeColor.Text === 'bk8'"
                      icon="fa-solid fa-users"
                      class="!fill-[var(--text5)] icon w-6 h-6"
                     />
                    <svg-icon
                      v-else
                      svg-name="icon-newReferral"
                      class="!fill-[var(--text5)] icon w-6 h-6"
                    />
                    <!-- <img :src="getAssetImage('assets/theme/new_black_theme/profile/Referral.svg')" alt="" class="m-0 w-[24px] h-[24px]"> -->
                    <span class="profile-menu-title">{{ $t("referral") }}</span>
                  </div>
                  <div class="flex items-center m-angle-right-container">
                    <font-awesome-icon icon="angle-right" />
                  </div>
                </div>
              </nuxt-link>
              <nuxt-link
                to="/messages"
                class="py-[16.5px] m-profile-menu-item"
                :id = "`${ID.USER_CENTER.MESSAGE}`"
              >
                <div class="flex justify-between pointer-events-none">
                  <div class="flex items-center fc-text">
                    <svg-icon
                      svg-name="icon-message-fill"
                      class="!fill-[var(--text5)] icon w-6 h-6"
                      />
                    <span class="profile-menu-title">{{ $t("messages") }}</span>
                    <MessagesMessageCount
                      v-if="unreadInfo?.TotalCount"
                      :count="unreadInfo.TotalCount"
                      :is-unread="true"
                      class="!ml-2"
                    ></MessagesMessageCount>
                  </div>
                  <div class="flex items-center m-angle-right-container">
                    <font-awesome-icon
                      icon="angle-right"
                      />
                  </div>
                </div>
              </nuxt-link>
              <div
                v-if="!agentCooperation.IsHidden"
                class="py-[16.5px] m-profile-menu-item"
                @click="toggleAgentCooperation"
              >
                <div class="flex justify-between pointer-events-none">
                  <div class="flex items-center fc-text">
                    <svg-icon
                      svg-name="icon-people"
                      class="!fill-[var(--text5)] icon w-6 h-6"
                    />
                    <!-- <img :src="getAssetImage('assets/svg-icon/people.svg')" class="m-0 w-[24px] h-[24px]"> -->
                    <span class="profile-menu-title">{{
                      $t("agent_cooperation")
                    }}</span>
                  </div>
                  <div class="flex items-center m-angle-right-container">
                    <font-awesome-icon icon="angle-right" />
                  </div>
                </div>
              </div>
            </div>
          </div>
          <div class="flex flex-col rounded-lg px-5 bg-background5 mt-[10px]" v-if="!isHelpCenterHidden">
            <nuxt-link
              class="py-[16.5px] m-profile-menu-item"
              to="/help-center"
            >
              <div class="flex justify-between">
                <div class="flex items-center fc-text">
                  <svg-icon
                    svg-name="icon-help-center-new"
                    class="!fill-[var(--text5)] icon w-6 h-6"
                  />
                  <!-- <img :src="getAssetImage('assets/theme/new_black_theme/AboutUs.svg')" alt="" class="m-0 w-[24px] h-[24px]"> -->
                  <span class="profile-menu-title">
                    {{
                      isPlayful
                        ? $t("about_us")
                        : $t("help_center")
                    }}
                  </span>
                </div>
                <div class="flex items-center m-angle-right-container">
                  <font-awesome-icon icon="angle-right" />
                </div>
              </div>
            </nuxt-link>
          </div>
          <div
            class="flex flex-col px-5 rounded-lg bg-background5 lang-wr-option-container"
          >
            <el-collapse v-model="activeNames">
              <el-collapse-item name="language">
                <template #title>
                  <div class="flex items-center justify-between w-full">
                    <div class="flex items-center fc-text">
                      <div class="icon-lang">
                        <img
                          :src="
                            getAssetImage(
                              `assets/materials/languageIcon/${defaultLanguage}.svg`
                            )
                          "
                          alt=""
                        />
                      </div>
                      <span class="profile-menu-title">{{
                        defaultLanguageForDisplay
                      }}</span>
                    </div>
                    <div class="flex items-center m-angle-right-container">
                      <font-awesome-icon
                        icon="angle-down"
                        class="m-language-collapse"
                      />
                    </div>
                  </div>
                </template>
                <div>
                  <div v-for="(lang, index) in languages" :key="index">
                    <div
                      class="flex items-center cursor-pointer padding-y fc-text"
                      @click="switchLanguage(lang.ISO)"
                    >
                      <div class="icon-lang">
                        <img
                          :src="
                            getAssetImage(
                              `assets/materials/languageIcon/${lang.ISO}.svg`
                            )
                          "
                          alt=""
                          :loading="lazy"
                        />
                      </div>
                      <div class="profile-menu-title">
                        {{ lang.LanguageLocalName }}
                      </div>
                    </div>
                  </div>
                </div>
              </el-collapse-item>
            </el-collapse>
          </div>
          <div class="flex flex-col px-5 rounded-lg bg-background5 mb-[10px]">
            <div class="py-[16.5px] m-profile-menu-item" @click="onLogout">
              <div class="flex justify-between">
                <div class="flex items-center fc-text">
                  <svg-icon
                    svg-name="icon-sign-out-new"
                    class="!fill-[var(--text5)] icon w-6 h-6"
                  />
                  <!-- <img :src="getAssetImage('assets/theme/new_black_theme/SignOut.svg')" class="m-0 w-[24px] h-[24px]"> -->
                  <span class="profile-menu-title">{{ $t("logout") }}</span>
                </div>
                <div class="flex items-center m-angle-right-container">
                  <font-awesome-icon icon="angle-right" />
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
    <div class="flex w-full justify-end pr-2 relative z-10" v-if="themeColor.Text.includes('global') || themeColor.Text.includes('playful')">
      <theme-desktop-global-components-menu-drawer v-if="!isBSI"/>
    </div>
    <new-black-theme-hamburger-menu v-else />
  </div>
</template>

<script lang="ts">
import { computed, defineComponent, ref } from "vue";
import {
  useLanguageComponent,
  useHeaderComponent,
} from "@/composables/useTheme";
import { store } from "@/store";
import { appStore } from '~~/store/app';
import { IThemePropertiesFromApi } from '~~/models/companyThemePropertiesRespone';
import { ID } from "~~/utils/constants";

export default defineComponent({
  name: "Profile",
  setup() {
    const activeNames = ref([]);
    const router = useRouter();
    const toggleAgentCooperation = () => {
      store.commit(
        "updateAgentCooperationDialog",
        !store.state.showAgentCooperationDialog
      );
    };
    const { logout, referralEnabled, agentCooperation, isReferralV2Enabled } = useHeaderComponent();
    const isPlayful = computed(
      (): boolean => store.state.selectedThemeName === "playful"
    );
    const isShowReferralPage = computed(() => store.state.IsShowReferralPage);
    const themeProperties = computed(
      () => store.state.companyThemePropertiesFromApi.ThemeProperties
    );
    const isHelpCenterHidden = computed(
      (): IThemePropertiesFromApi =>
        themePropertyHelper.getSingleThemeProperty(
          themeProperties.value,
          "help_center"
        )
    ).value.IsHidden;
    const onLogout = () => {
      logout();
    };

    const {
      languages,
      defaultLanguage,
      switchLanguage,
      defaultLanguageForDisplay,
    } = useLanguageComponent();
    const isBSI = computed(() => !store.state.auth);
    const onNavigateToPage = (url: string) => {
      if (isBSI.value) {
        router.push("/login");
      } else {
        window.open(url, "_blank");
      }
    };
    const { getAssetImage } = commonHelper;
    const accountBgImg = `url(${getAssetImage(
      "assets/theme/new_black_theme/profile_bg.png"
    )})`;
    const { themeColor } = themePropertyHelper;
    const { fetchMessages, unreadInfo } = useMessage();
    const route = useRoute();
    onMounted(() => {
      if (!route.fullPath.includes("messages")) {
        fetchMessages();
      }
    });
    watch(() => route.path, (path) => {
      if (String(path).includes("profile")) {
        document.body.classList.add("bo-hidden");
      } else {
        document.body.style.overflow = "";
      }
    }, {
      immediate: true,
    });
    onBeforeRouteLeave(() => {
      document.body.classList.remove("bo-hidden")
    });
    return {
      isPlayful,
      activeNames,
      languages,
      defaultLanguage,
      switchLanguage,
      defaultLanguageForDisplay,
      isBSI,
      onLogout,
      onNavigateToPage,
      referralEnabled,
      agentCooperation,
      getAssetImage,
      accountBgImg,
      toggleAgentCooperation,
      themeColor,
      isReferralV2Enabled,
      isShowReferralPage,
      isHelpCenterHidden,
      unreadInfo,
    };
  },
});
</script>

<style lang="scss" scoped>
.el-collapse {
  --el-collapse-content-bg-color: none;
  --el-collapse-header-bg-color: none;
  border: none;
  :deep(.el-collapse-item__arrow) {
    font-weight: bold;
    color: var(--text);
  }
}
:deep(.icon svg) {
  width: 24px;
  height: 24px;
}
:deep(.icon svg path) {
  fill: var(--text);
}
.icon-lang {
  img {
    width: 100%;
    height: 100%;
    border-radius: 2px;
    object-fit: cover;
  }
  height: 16px;
  width: 22px;
  border-radius: 2px;
  background: #fff;
}
.svg-inline--fa {
  color: var(--text);
}
[theme-color="bk8_green"] .hamburger-pos {
  @apply left-4;
  top: 13px;
}
</style>
<style lang="scss">
.background-header-title {
  position: absolute;
  height: 184px;
  width: 100%;
  background-color: var(--background4);
  top: 0;
  left: 0;
  &::before {
    content: "";
    position: absolute;
    top: 0;
    left: 0;
    height: 100%;
    width: 100%;
    background: var(--background4);
  }
  > div {
    position: absolute;
    &:first-child {
      background: linear-gradient(
        199.22deg,
        rgba(255, 255, 255, 0) 12.93%,
        rgba(255, 255, 255, 0.1) 83.18%
      );
      width: 170px;
      height: 170px;
      border-radius: 50%;
      top: -75px;
      left: -33px;
      transform: rotate(75deg);
    }
    &:nth-child(2) {
      background: linear-gradient(
        219.67deg,
        rgba(255, 255, 255, 0) 22.41%,
        rgba(255, 255, 255, 0.1) 116.98%
      );
      width: 370px;
      height: 370px;
      border-radius: 50%;
      top: -152px;
      left: 77px;
    }
    &:last-child {
      background: linear-gradient(
        199.22deg,
        rgba(255, 255, 255, 0) 12.93%,
        rgba(255, 255, 255, 0.1) 83.18%
      );
      width: 250px;
      height: 250px;
      border-radius: 50%;
      top: -147px;
      right: -69px;
    }
  }
}
.m-account-header-title::before {
  background-image: v-bind(accountBgImg);
  content: "";
  height: 184px;
  left: 0;
  position: fixed;
  top: 0;
  width: 100%;
  background-size: cover;
  filter: grayscale(100%);
}
.m-profile-menu-item {
  border-bottom: 0.5px solid #393c68;
}
.m-profile-menu-item:last-child {
  border-bottom: none;
}
.m-angle-right-container {
  height: 21.83px;
  width: 21.83px;
  display: flex;
  justify-content: center;
  color: var(--textBtn);
}
.m-angle-right-container svg {
  font-size: 16.31px;
}
.profile-menu-title {
  font-size: 14px;
  color: var(--text5);
  margin-left: 8.73px;
}
.el-collapse-item__arrow {
  display: none;
}
.el-collapse-item__header,
.el-collapse-item__wrap {
  border-bottom: unset;
}
.el-collapse-item .m-language-collapse {
  transition: transform 0.3s ease-in-out;
}
.el-collapse-item.is-active .m-language-collapse {
  transform: rotate(-180deg);
}
.lang-wr-option-container {
  padding-top: 4.87px;
  padding-bottom: 4.87px;
  margin-top: 10px !important;
  margin-bottom: 10px !important;
}
.m-profile-item-btn {
  font-size: 15.82px;
  color: var(--textBtn);
  border: unset;
  padding: var(--padding-x);
  height: 52.31px;
  border-radius: 0.5rem;
}
.padding-y {
  padding-top: 12.25px;
  padding-bottom: 12.25px;
}
.m-margin-unset {
  margin-top: 10px;
}
</style>
